Subject: Re: [proposed patch] via-rhine: prevent oops when requesting an IRQ

From: Chuck Ebbert <[email-masked]>
Date: Mon, 10 Nov 2008 17:28:36 -0500

On Thu, 06 Nov 2008 01:07:41 -0500
Jeff Garzik <[email-masked]> wrote:

> Chuck Ebbert wrote:
> > via-rhine: prevent oops when requesting an IRQ
> > 
> > via-rhine requests an IRQ before it's ready to handle an interrupt.
> > It oopses when CONFIG_DEBUG_SHIRQ is enabled.
> > 
> > https://bugzilla.redhat.com/show_bug.cgi?id=469303
> > 
> > ---
> > 
> > NOTE: UNTESTED: Is it okay to init the hardware before requesting the
> > IRQ, or should that be done afterward?
> 
> First of all, _ideally_ your interrupt handler should be able to any 
> state of software initialization, once registers are mapped.  So I would 
> first concentrate on "hardening" the interrupt handler, if feasible.
> 
> It is certainly a common technique to disable interrupts somehow, during 
> initialization of the hardware.  Note, though, that doing things before 
> request_irq() is no real guarantee you are out of danger -- you might be 
> on a shared PCI irq, and your init causes that interrupt to "scream" 
> even though your driver has not registered the irq.
> 

The problem with this driver is that it doesn't call alloc_ring() before
request_irq() and then it oopses in the interrupt handler trying to access
the ring.